#ifndef __TAB1D__HH__
#define __TAB1D__HH__

#include "vector.hh"
#include <stack>
using namespace std;

#define NB_LINES  100
#define SIZE_LINE 128

#define NULL_VECTOR ((X*) NULL)

/** Infinite 1D array, returning a default value when asked for an unexisting index,template class. you need to use the macro INSTAN(X), in instanciation.cc,
in order to instanciate a tab1d<X>*/
template <class X>
class tab1d
{
protected:
  // Pointor on the elements' array
  vect<X *> *tab;
  // Stack that hold free columns
  static stack<vect<X *> *> col;
  // Stack that hold free lines
  static stack<X *> lin;

  X* alloc_line();
  void free_line(X*);
  void free_line(int);

  vect<X*>*  alloc_column();
  void free_column(vect<X *>*);
  void clear_column(vect<X *>*);

public:
  /// Default value of the tab's elements
  static X Def_val;
  /// Constructor
  tab1d();
  /// Copy constructor
  tab1d(const tab1d<X> &);
  /// Destructor
  virtual ~tab1d();

  /// Reaffectation operator
  tab1d<X> &operator = (const tab1d<X> &);
  /// Reinitialize all the data
  void reinit();
  /// Access an element of the table
  virtual X operator() (long) const;
  /// Access a reference to an element of the table
  virtual X & operator[] (long);
  /// Sets the value returned for an inexisting index
  void set_def_val(const X&);
};
#endif // __TAB1D__HH__
