#include "format.hh"

vector<format*> format::tab_format;

format::format():num_format(-1)
{
}
format::format(int num):num_format(num)
{
}
format::format(const format& cp):num_format(cp.num_format)
{
}
format::format(const char* name)
{
  set(name);
}
format::format(format* new_format)
{
  tab_format.push_back(new_format);
  num_format = tab_format.size()-1;
}
bool format::operator ()()
{
  /* No format available */
  if(tab_format.empty())
    return false;
  /* No format specified */
  if (num_format < 0)
    return false;
  /* Check if specified format has been find amoung available ones*/
  
  return num_format<(int)tab_format.size();
}
bool format::operator ! ()
{
  return !((*this)());
}
format& format::operator=(const format& form)
{
  num_format=form.num_format;
  return *this;
}
format& format::set(const char* name)
{
  for(num_format=0;num_format<(int)tab_format.size();num_format++)
    {
      if(tab_format[num_format]->is_format(name))
	break;
    }
  return *this;
}
int format::load(const char* name,
		 int& dim ,
		 int & width,
		 int & heigth,		 
		 unsigned char* & begin)
{
  /* problem with the format (not set, not available, not find) */
  if(!(*this))
    return -1;

  return tab_format[num_format]->load(name,dim,width,heigth,begin);
}
int format::save(const char* name,
		 int dim,
		 int  width,
		 int  heigth,
		 unsigned char*  begin)
{
  /* problem with the format (not set, not available, not find) */
  if(!(*this))
    return -1;
  
  return tab_format[num_format]->save(name,dim,width,heigth,begin);
}
ostream& format::to_stream(ostream& o,
			   int dim,
			   int  width,
			   int  heigth,
			   unsigned char*  begin)
{
  /* problem with the format (not set, not available, not find) */
  if(!(*this))
    return o;
  
  return tab_format[num_format]->to_stream(o,dim,width,heigth,begin);
}
