#include "color_and_border_set.hh"


void color_and_border_set::init(combi_map_base &base)
{
  dart b, sig;
  vertex v_b=base.give_background();

  while(--v_b)
  {
    v_data->init(base, v_b);
    b = sig = v_b;
    do
    {
      b_data->init(base, sig);
      sig = base.sigma(sig);
    }
    while(b!=sig);
  }
}

void color_and_border_set::contract_edge(int level, 
					 dart b1, 
					 dart b2, 
					 vertex v1, 
					 vertex v2)
{
  int front = -(*b_data)(b1).give_cardinal();
  (*v_data)(v1).add_perimetre(front);
  (*v_data)(v2).add_perimetre(front);
  b_data->del(b1);
  b_data->del(b2);
}
void color_and_border_set::remove_empty_self_loops(dart b, dart mb, vertex v)
{
  (*v_data)(v).add_perimetre( -2*(*b_data)(b).give_cardinal() );
  b_data->del(b);
  b_data->del(mb);
}
void color_and_border_set::remove_double_edges(int level, dart b, dart sig_b)
{
  b_data->merge(level, b, sig_b);
  b_data->del(sig_b);
}
void color_and_border_set::update_vertex_set(int level, vertex v, vertex f_v)
{
  if (v==f_v)
    return;
  v_data->merge(level,f_v,v);
  v_data->del(v);
}
