/** \file combi_map_priv.hh
    \brief File for the combinatorial maps used in the pyramid */

#ifndef __COMBI_MAP_PRIV__
#define __COMBI_MAP_PRIV__

#include "combi_map_gen.hh"


/** Class for the combinatorial maps used in the pyramid */
class combi_map_priv: public combi_map_gen
{
public:
  /// Constructor
  combi_map_priv(pyramid &P):combi_map_gen(&P)
  {}
  /// Virtual destructor
  virtual ~combi_map_priv()
  {}
  /// Function to read the sigma of one dart of the combinatorial map
  dart sigma(dart d) const
  {
    return sig(d);
  }
  /// Function that compute sigma precedent
  dart alpha(dart d) const
  {
    return alph(d);
  }
  /// Function that give the number of edge
  int give_nb_edge() const
  {
    return nb_edge;
  }
  /// Function that give the backround value
  unsigned long give_background() const
  {
    return background;
  }

};

#include "combi_map_gen.hh"


#endif // __COMBI_MAP_PRIV__
