/** \file equivalent_mont_jolion.hh
    \brief File used to determine if two vertices are equivalent */

#ifndef __EQUIVALENT_MONT_JOLION_HH__
#define __EQUIVALENT_MONT_JOLION_HH__

#include "equivalent.hh"

/** Model class used to determine if two vertices are equivalent */
class equivalent_mont_jolion: public equivalent
{
protected:
  // Pointor on the vertex dataset
  const vertex_data *v_data;
  // Pointor on the border dataset
  const border_data *b_data;
public:
  /// Constructor
  equivalent_mont_jolion(const vertex_data &v, const border_data &b):v_data(&v),b_data(&b)
  {}
  /// Virtual destructor
  virtual ~equivalent_mont_jolion()
  {}
  /// Pure virtual function to know if the two vertices must be merged
  virtual bool lambda(int,vertex,vertex,dart,dart)=0;
  /// Pure virtual function to compute the surviving criterion of a vertex
  /// That will be minimized during the reduction process
  virtual double value(vertex)=0;
  /// Pure virtual function to compute the merging interset of between two vertices
  /// That will be minimized during the reduction process
  virtual double interest(int,vertex,vertex,dart,dart)=0;
};

#endif // __EQUIVALENT_MONT_JOLION_HH__
