#include "equivalent_preserve_edge.hh"

#define MIN(a,b) ((a)<(b)?(a):(b))
#define MAX(a,b) ((a)<(b)?(b):(a))


bool equivalent_preserve_edge::lambda(int level,vertex v1,vertex v2,dart b1,dart b2)
{
  vertex_data_color *V_data = ((vertex_data_color *)v_data);
  border_data_deriche *B_data = ((border_data_deriche *)b_data);
  int dim=V_data->give_dim_color(),k;
  double res,C1[3],C2[3],grad;

  (*V_data)(v1).give_mean(C1);
  (*V_data)(v2).give_mean(C2);


  for (int k=0;k<dim;k++)
    res+=(C1[k]-C2[k])*(C1[k]-C2[k]);

  grad  = (*B_data)(b1).give_gradient();
  grad += (*B_data)(b2).give_gradient();
  k  = (*B_data)(b1).give_cardinal();
  grad/=(k+k);

  return (grad<grad_threshold && res<grey_threshold);
}
double equivalent_preserve_edge::value(vertex v)
{
  return (*((vertex_data_color *)v_data))(v).give_se();
}
double equivalent_preserve_edge::interest(int level,vertex v1,vertex v2,dart b,dart m_b)
{
  border_data_deriche *B_data = ((border_data_deriche *)b_data);
  vertex_data_color *V_data = ((vertex_data_color *)v_data);
  int p1, p2, front;
  double g, d1, d2, k;
  double g_max=B_data->give_max_gradient();

  g =(*B_data)(b).give_gradient();
  front = (*B_data)(b).give_cardinal();
  k =g_max*front;
  d1=g/k;
  g =(*B_data)(m_b).give_gradient();
  d2=g/k;
  d1=MAX(d1,d2);

  p1=(*V_data)(v1).give_perimetre();
  p2=(*V_data)(v2).give_perimetre();
  d2=(double)MIN(p1, p2)/(8.0*front);

  return d1*d2;
}
