#include "k_sort.hh"

k_sort::k_sort(int max):max(MAXFLOAT)nb_vertex(0),nb_max_vertex(max)
{
  tab=new k_sort::node[nb_max_vertex];
}
k_sort::insert(vertex v,float val)
{
  int i;
  int elt;

  if((val>=max)&&(nb_vertex==nb_max_vertex))
    return;
  if(nb_vertex==0)
    {
      tab[0].v=v;
      tab[0].dist=val;
      tab[0].next=-1;
      tab[0].previous=-1;
      return;
    }      
  if(nb_vertex<nb_max_vertex)
    {
      elt=nb_vertex;
      nb_vertex++;
    }
  else
    {
      elt=end;
      tab[tab[end].previous].next=-1;
    }

  tab[elt].v=v;
  tab[elt].dist=val;
  tab[elt].next=-1;
  update_link(tab[elt],elt);
  
}

k_sort::update_link(k_sort::node & n,int index)
{
  int current=begin;
  int last=-1;

  while((tab[current].dist < n.dist)&&(current != end))
    {
      last=current;
      current=tab[current].next;
    }
  if(current==end)
    {
      if(n.dist <tab[current].dist)
	{
	  if(end ==begin)
	    n.previous=-1;
	  else
	    {
	      n.previous=tab[current].previous;
	      tab[n.previous].next=index;
	    }
	  
	  n.next=current;
	  tab[current].previous=index;
	  if(last == -1)
	    begin=index;
	}
      else
	{
	  tab[current].next=index;
	  n.previous=current;
	  end=index;
	}
      return;
  }
  n.next=current;
  n.previous=tab[current].previous;
  tab[n.previous].next=index;
  tab[current].previous=index;
}
