#include <assert.h>
#include "max_min1d.hh"

#define MIN(a,b) ((a)<(b)?(a):(b))

tab_ptr maxi::garbage;
int     maxi::card(0);

tab_ptr mini::garbage;
int mini::card(0);


void mini::set_from_maxi(maxi& max)
{
  maxi *max1,*max2;
  mini *min1,*min2;
  
  min1=(mini*)max.left;
  min2=(mini*)max.right;
  
  max1=(maxi*)min1->left;
  max2=(maxi*)min2->right;
  
  left=max1;
  max1->right=this;
  right=max2;
  max2->left=this;
  begin=min1->begin;
  end=min2->end;

  value=max.value;
  index=max.index;
}
mini:: mini(maxi& max): max_min(max.value,max.index)
{
  set_from_maxi(max);
}
void mini::compute_volume(tab_dart& profil,int card)
{
  int height=MIN(left->value,right->value);
  
  volume=(end-begin)*(height-value);
  
  while( (profil[begin]< height) && (begin>0) )
    {
      volume+= height-profil[begin];
      begin--;
    }
  if(end==index)
    end++;
  while( (profil[end]<height) && (end<card))
    {
      volume+=height-profil[end];
      end++;
    }
  if(volume <0)
    {
      cerr << "Erreur volume ngatif:"<<endl;
      int i=0;
      cerr <<"-1 255"<<endl;
      while(profil(i)!= 0)
	{
	  cerr <<i<<" "<<profil(i)<<endl;
	  i++;
	}
    }
      assert(volume>=0);
}            
maxi* alloc_maxi(int val,int ind)
{
  if(maxi::card == 0)
    return new maxi(val,ind);
  maxi::card--;
  maxi* ptr=(maxi*)(maxi::garbage(maxi::card));
  maxi::garbage[maxi::card]=NULL;
  ptr->value=val;
  ptr->index=ind;
  ptr->left=ptr->right=NULL;  
  return ptr;
}
void delete_maxi(maxi* max)
{
  maxi::garbage[maxi::card]=(any_ptr)max;
  maxi::card++;
}


mini* alloc_mini(maxi& max)
{
  if(mini::card==0)
    return new mini(max);

  mini::card--;
  mini* elt=(mini*)(mini::garbage(mini::card));
  mini::garbage[mini::card]=NULL;
  elt->set_from_maxi(max);
  
  return elt;
}
mini* alloc_mini(int val,int ind)
{
  if(mini::card==0)
    return new mini(val,ind);
  mini::card--;
  mini* elt=(mini*)(mini::garbage(mini::card));
  mini::garbage[mini::card]=NULL;
  elt->begin=elt->end=elt->index=ind;
  elt->value=val;
  elt->left=elt->right=NULL;
  elt->volume=0;
  
  return elt;
}
void delete_mini(mini* elt)
{
  mini::garbage[mini::card]=(any_ptr)elt;
  mini::card++;
}
void remove_max(maxi* cur_max,
		mini*& min_min,
		tab_dart& profil,
		int card)
{
  mini *min1((mini*)cur_max->left),*min2((mini*)cur_max->right);
  
  min1->compute_volume(profil,card);
  min2->compute_volume(profil,card);

  //  cout << "Min1 :"<<min1->value<<"("<<min1->volume<<")"<<endl;
  //  cout << "Min2 :"<<min2->value<<"("<<min2->volume<<")"<<endl;
  mini * new_min=alloc_mini(*cur_max);
  
  if(min_min == NULL)
    min_min=min1;
  else
    if(min_min->volume < min1->volume)
      {
	delete_mini(min_min);
	min_min=min1;
      }
    else
      delete min1;
  if(min_min->volume<min2->volume)
    {
      delete_mini(min_min);
      min_min=min2;
    }
  else
    delete_mini(min2);
  
  delete_maxi(cur_max);
}
