
/** \file rm_watershed.hh
    \brief aggregation of vertices marked as watersheds to their
    deepest bassins  */
#ifndef __RM_WATERSHEDS_HH__
#define __RM_WATERSHEDS_HH__

#include "kernel.hh"
#include "watershed.hh"
class missed_watershed
{
public:
  missed_watershed()
  {}
  missed_watershed(const char*messg ,const char* file,int line)
  {
    cerr << messg<< "File : "<<file<<", Line : "<<line<<endl;
  }
};
class rm_watersheds : public kernel
{
private:
  watershed* bassins;
  int nb_iter;
  void contract_edge(combi_map_priv&,int,vertex,dart);
  vertex min_altitude(fifo_label*,int) throw (missed_watershed);
public:
  /// constructor 
  rm_watersheds(watershed&);
  virtual ~rm_watersheds();
  void compute_kernel(combi_map_priv &);
  bool continue_computation();
};
#endif 
  
