#ifndef __WATER_VERTEX_DATA_HH__
#define __WATER_VERTEX_DATA_HH__

#include <tab_label.hh>
#include <image.hh>
#include <string.h>
#include "vertex_data.hh"
#include <tab_ptr.hh>

class water_vertex_data : public vertex_data
{
private:
  //maximal depths of the bassins
  tab_label depths;
  tab_ptr tab_moments;

  // gragient image.
  image *grad;
  image * img;
public:

  /// Constructor with the initial image and the alpha coefficient for
  /// deriche operator.
  water_vertex_data(image&,image&);
  virtual ~water_vertex_data()
  {}

  /// Access an element of dataset
  int  give_depth(vertex) const;
  void set_depth(vertex,int);
  ///  initialize the vertex_value of the vertex
  void init(combi_map_base &,vertex);

  /// Function to manage the vertex_value during the merge of two vertices
  void merge(int,vertex,vertex);
};
  
#endif /* water_vertex_data.hh */
